# imported from,
#https://github.com/tomaspinho/rtl8821ce.git master,new on Oct232019

%global	module	8821ce
%global pname rtl%{module}


Name:		dkms-%{pname}
Version:	5.5.2
Release:	%mkrel 6
Source0:	%{pname}-%{version}.tar.xz
License:	GPLv2
Group:		System/Kernel and hardware
URL:		https://github.com/tomaspinho/rtl8821ce.git
Summary:	dkms package for realtek 8821ce driver 
#Patch0:		rtl8821ce-1.0.6-5.5.2-newver.patch
Patch1:		rtl8821ce-5.5.2-newver-29Nov2019.patch
Patch2:		rtl8821ce-rtw_cfgvendor.c.patch
Patch3:		rtl8821ce-rtw_proc.patch
Patch4:		rtl8821ce-fix-compile-on-kernel-5.8.patch

BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot
Requires:   gcc >= 9.2.0
Requires(post):		dkms
Requires(preun):	dkms
 
Obsoletes:	%{name} < %{version}-%{release}

%description
802.11ac/abgn PCIe WLAN with Bluetooth 4.2 Single-Chip Controller
The Realtek RTL8821CE-CG is a highly integrated single-chip
that supports 1-stream 802.11ac solutions with Multi-user
MIMO (Multiple-Input, Multiple-Output) and Wireless LAN (WLAN)
PCI Express network interface controller with integrated Bluetooth 2.1/3.0/4.2
USB interface controller. It combines a WLAN MAC, a 1T1R capable WLAN baseband,
and RF in a single chip.
The RTL8821CE-CG provides a complete solution
for a high-performance integrated wireless and Bluetooth device.
 
Features
    TFBGA 5.2x5.2mm package
    802.11ac/abgn
    802.11ac 1x1, Wave-2 compatible with MU-MIMO
    Bluetooth 4.2 
    Host interface
    PCI Express 1.1 for WLAN controller
    USB2.0 for Bluetooth controller

Hint: many newer Laptops HP have this chip

PCIe Activate State Power Management
Your distribution may come with PCIe Active State Power Management enabled by default.
That may conflict with this driver. To disable:
sudo $EDITOR /etc/default/grub

Add pci=noaer at the end of GRUB_CMDLINE_LINUX_DEFAULT. Line should look like this:
GRUB_CMDLINE_LINUX_DEFAULT="quiet splash pci=noaer"

Then update your GRUB configuration:
sudo update-grub
Reboot.

Lenovo Yoga laptops
Some new Yoga laptops (like the Yoga 530) come with rtl8821ce as the Wi-Fi/Bluetooth chip. But the ideapad-laptop module, which may come included in your distribution, may conflict with this driver. To disable:
sudo modprobe -r ideapad_laptop

%prep
%setup -qn %{pname}-%{version}
find -type f -exec chmod 0644 {} \;

%apply_patches

unn=`ls hal/btc | grep -v "8821c\|halbtcoutsrc.h\|mp_precomp.h"`
for i in $unn; do
rm -f hal/btc/$i
done

%install
%__rm -rf %{buildroot}
#%__install -dm755 %{buildroot}/lib/firmware
%__install -dm755 %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}
%__cp -a . %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}
#%__mv -f %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/regdb/* %{buildroot}/lib/firmware/
#%__rm -f %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/{CONTRIBUTORS.md,LICENSE,README.md}
%__cat <<EOF > %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/dkms.conf
PACKAGE_NAME="%{pname}"
PACKAGE_VERSION="%{version}-%{release}"
BUILT_MODULE_NAME="rtl%{module}"
BUILT_MODULE_LOCATION="./"
MAKE="'make' SKIP_STACK_VALIDATION=1 all"
CLEAN="'make' clean"
DEST_MODULE_LOCATION="/kernel/3rdparty/%{pname}"
AUTOINSTALL="yes"
EOF

%post -n %{name}
needadd=`cat /lib/module-init-tools/ldetect-lst-modules.alias | grep rtl8821ce`
if [ -z "$needadd" ]; then
echo "alias pci:v000010ECd0000C82Bsv*sd*bc*sc*i* rtl8821ce
alias pci:v000010ECd0000C82Asv*sd*bc*sc*i* rtl8821ce
alias pci:v000010ECd0000C821sv*sd*bc*sc*i* rtl8821ce" >> /lib/module-init-tools/ldetect-lst-modules.alias
fi

# set pci=noaer at the end of /etc/default/grub - line 1 and


/usr/sbin/dkms --rpm_safe_upgrade add -m %{pname} -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade build -m %{pname} -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade install -m %{pname} -v %{version}-%{release}

if [ "$1" = 1 ]; then
if [ -f /etc/NetworkManager/NetworkManager.conf ]; then
randmacad=`grep "wifi.scan-rand-mac-address=no" /etc/NetworkManager/NetworkManager.conf`
fi
if [ "$randmacad" = z ]; then
echo "
[device]
wifi.scan-rand-mac-address=no
" >> /etc/NetworkManager/NetworkManager.conf
fi
/sbin/modprobe %{pname} >/dev/null 2>&1
echo "Reloading network configuration ... "
/sbin/service network reload >/dev/null 2>&1
echo "%{pname}" >> /etc/modprobe.preload
fi

# tell user to need reboot at here follow finished
echo "to use it you must reboot !"


%preun -n %{name}
/usr/sbin/dkms --rpm_safe_upgrade remove -m %{pname} -v %{version}-%{release} --all

if [ "$1" = 0 ]; then
/sbin/rmmod %{pname} >/dev/null 2>&1
echo "Reloading network configuration ... "
/sbin/service network reload >/dev/null 2>&1
sed -i '/%{pname}/ d' /etc/modprobe.preload
fi
## remove module-destdir just if it empty after dkms remove,(user's only deinstall after testing)... ##
## so prevent we not have empty folders in kernel-tree for next mklivecd ##
if [ ! -f /lib/modules/*/kernel/3rdparty/%{pname}/* ]; then
rm -r /lib/modules/*/kernel/3rdparty/%{pname} >/dev/null 2>&1
fi

%clean
%__rm -rf %{buildroot}

%files
#%doc README.md Realtek_Changelog.txt
##CONTRIBUTORS.md LICENSE 
%defattr(-,root,root)
%{_usrsrc}/%{pname}-%{version}-%{release}
#/lib/firmware/*


%changelog
* Sun Jun 28 2020 onkelho <oh.quait at gmail.com> - 5.5.2-6pclos2020
- rebuild add patch for linux-5.8

* Sat Apr 25 2020 onkelho <oh.quait at gmail.com> - 5.5.2-5pclos2020
- test-rebuild add P2+P3 from endlessm to cleanly sources
- remove unneeded files from source

* Tue Apr 07 2020 onkelho <oh.quait at gmail.com> - 5.5.2-4pclos2020
- rebuild two fixes:
- fix naming of physical layer for 22MB and 33MB data rates
- Add missing supplier data rates (22, 33MB)

* Mon Mar 09 2020 onkelho <oh.quait at gmail.com> - 5.5.2-3pclos2020 
- rebuild --add support for kernel-5.6rc1

* Thu Jan 02 2020 onkelho <oh.quait at gmail.com> - 5.5.2-2pclos2020 
- rebuild --Update rtl8821ce_halmac.c Nov29.2019

* Wed Nov 13 2019 onkelho <oh.quait at gmail.com> - 5.5.2-1pclos2019 
- rebuild set source-version as package-version = 5.5.2
- fix-build-with-make (4days before)

* Wed Oct 23 2019 onkelho <oh.quait at gmail.com> - 1.0.6-4pclos2019
- new version release sourceversion-5.5.2_34066.20190614 now in master
- should working on kernel-5.3...and 5.4..

* Tue Aug 13 2019 tex - 1.0.6-3pclos2019
- rebuild against updates

* Mon Jul 15 2019 onkelho <oh.quait at gmail.com> 1.0.6-2pclos2018
- new ver - rel switch source to tomas
- readd networkmanager-mac-scan-opts in %post

* Sun Jun 23 2019 onkelho <oh.quait at gmail.com> 1.0.6-1pclos2019
- new - switch source to endlessm-linux

* Fri Jun 21 2019 onkelho <oh.quait at gmail.com> 1.0.5-1pclos2019
- new ver -add modaliases from debian
- fix, removed networkmanager-mac-scan-opts in %post
- - this was come in from other specs 

* Wed Jun 19 2019 onkelho <oh.quait at gmail.com> 1.0.4-2pclos2019
- rebuild
- fix compilation on kernel-5.1...

* Mon May 13 2019 onkelho <oh.quait at gmail.com> 1.0.4-1pclos2019
- pump version - 1.0.4

* Tue Apr 07 2019 onkelho <oh.quait at gmail.com> 1.0.1-4pclos2019
- fix-compilation-5.1

* Mon Mar 11 2019 onkelho <oh.quait at gmail.com> 1.0.1-3pclos2019
- rebuild --update master, fix compat linux-5

* Fri Jan 11 2019 onkelho <oh.quait at gmail.com> 1.0.1-2pclos2019
- rebuild --add patch0

* Sun Oct 21 2018 onkelho <oh.quait at gmail.com> - 1.0.1-1pclos2018
- import from aur first build on pclos

